<?php defined('_JEXEC') or die('Restricted access');

if ($this->apikey == '') {
echo '<p>' . JText::_('Google Maps API Key Error') . '</p>';
} else {

	$document	= & JFactory::getDocument();
	$scriptLink	= 'http://www.google.com/jsapi?key='. $this->apikey;
	$document->addScript($scriptLink);
	
?><div style="margin:0;padding:0;text-align:center;">
	<div id="phoca_map" style="margin:0;padding:0;width:600px;height:520px;margin-bottom:5px;"></div>
</div>
<script type="text/javascript" defer="defer">//<![CDATA[
google.load("maps", "2.x");
google.load("search", "1");

/* Map */
var tstPhocaMap=document.getElementById('phoca_map');
var tstIntPhocaMap;
var mapPhocaMap;
/* Address */
var geocoder;
	
function CancelEvenPhocaMap(event) { 
	var e = event; 
	if (typeof e.preventDefault == 'function') e.preventDefault(); 
	if (typeof e.stopPropagation == 'function') e.stopPropagation(); 
	
	if (window.event) { 
		window.event.cancelBubble = true; // for IE 
		window.event.returnValue = false; // for IE 
	} 
}

function CheckPhocaMap()
{
	if (tstPhocaMap) {
		if (tstPhocaMap.offsetWidth != tstPhocaMap.getAttribute("oldValue"))
		{
			tstPhocaMap.setAttribute("oldValue",tstPhocaMap.offsetWidth);

			if (tstPhocaMap.getAttribute("refreshMap")==0) {
				if (tstPhocaMap.offsetWidth > 0) {
					clearInterval(tstIntPhocaMap);
					getPhocaMap();
					tstPhocaMap.setAttribute("refreshMap", 1);
				} 
			}
		}
		//window.top.document.forms.adminForm.elements.zoom.value = tstIntPhocaMap;
	}
}

function getPhocaMap(){
	if (tstPhocaMap.offsetWidth > 0) {
	
		mapPhocaMap = new GMap2(document.getElementById('phoca_map'));
		mapPhocaMap.addControl(new GMapTypeControl());
		mapPhocaMap.addControl(new GLargeMapControl3D());
		var overviewmap = new GOverviewMapControl();
		mapPhocaMap.addControl(overviewmap, new GControlPosition(G_ANCHOR_BOTTOM_RIGHT));
	
		mapPhocaMap.setCenter(new GLatLng(<?php echo $this->latitude;?>, <?php echo $this->longitude;?>), <?php echo $this->zoom;?>);
		//mapPhocaMap.setMapType(G_NORMAL_MAP);
		mapPhocaMap.enableContinuousZoom();
		mapPhocaMap.enableDoubleClickZoom();
		mapPhocaMap.enableScrollWheelZoom();
		mapPhocaMap.enableGoogleBar();
		
		/* Address*/
		geocoder = new GClientGeocoder();

		
		
		
		var startzoom = <?php echo $this->zoom;?>;
		var zoom = null;
		GEvent.addListener(mapPhocaMap, "zoomend", function(startzoom,zoom) {
			
			<?php if ($this->type == 'map') {
				?>
				window.top.document.forms.adminForm.elements.zoom.value = zoom;
				<?php
			}
			?>
		}); 
		 
		var marker = null;
		marker = new GMarker(new GLatLng(<?php echo $this->latitude;?>, <?php echo $this->longitude;?>), {draggable: true});
		mapPhocaMap.addOverlay(marker);
		GEvent.addListener(mapPhocaMap, 'click', function(overlay,point) {
			if (overlay) {
			} else {
				marker.setPoint(point);
				addPoint(point);
			}
		});

		GEvent.addListener(marker, "click", function() {
			var point = marker.getLatLng();
			marker.openInfoWindowHtml(marker.getLatLng().toUrlValue(6));
			addPoint(point);
		});

		function addPoint(point) {
			window.top.document.forms.adminForm.elements.latitude.value = point.y;
			window.top.document.forms.adminForm.elements.longitude.value = point.x;
			
			<?php if ($this->type == 'marker') {
				?>
				setPMGPSLatitude(point.y);
				setPMGPSLongitude(point.x);
				<?php
			}
			?>
			
		}
		
		GEvent.addDomListener(tstPhocaMap, 'DOMMouseScroll', CancelEvenPhocaMap);
		GEvent.addDomListener(tstPhocaMap, 'mousewheel', CancelEvenPhocaMap);
	}
}


function initialize() {
	if (GBrowserIsCompatible()) {
		
		tstPhocaMap.setAttribute("oldValue",0);
		tstPhocaMap.setAttribute("refreshMap",0);
		tstIntPhocaMap=setInterval("CheckPhocaMap()",500);
	}
}


/* Address */
// addAddressToMap() is called when the geocoder returns an
// answer.  It adds a marker to the map with an open info window
// showing the nicely formatted version of the address and the country code.
function addAddressToMap(response) {
  mapPhocaMap.clearOverlays();
  if (!response || response.Status.code != 200) {
	window.alert('<?php echo JText::_("Sorry, server was unable to geocode that address") ?>');
  } else {
	place = response.Placemark[0];
	point = new GLatLng(place.Point.coordinates[1],
						place.Point.coordinates[0]);
						
	window.top.document.forms.adminForm.elements.latitude.value = point.y;
	window.top.document.forms.adminForm.elements.longitude.value = point.x;
	<?php if ($this->type == 'marker') {
		?>
		setPMGPSLatitude(point.y);
		setPMGPSLongitude(point.x);
		<?php
	}
	?>
	
	marker = new GMarker(point);
	mapPhocaMap.addOverlay(marker);
	marker.openInfoWindowHtml(place.address + '<br />' +
	  '<b><?php echo JText::_('Country code') ?>:</b> ' + place.AddressDetails.Country.CountryNameCode);
  }
}

// showLocation() is called when you click on the Search button
// in the form.  It geocodes the address entered into the form
// and adds a marker to the map at that location.
function showLocation() {
  var address = document.forms[0].q.value;
  geocoder.getLocations(address, addAddressToMap);
}

// findLocation() is used to enter the sample addresses into the form.
function findLocation(address) {
  document.forms[0].q.value = address;
  showLocation();
}


google.setOnLoadCallback(initialize);
//]]></script>

<div>
	<form action="#" onsubmit="showLocation(); return false;">
    <?php echo JText::_('Set Coordinates by address');?> :
        <input type="text" name="q" value="" class="address_input" size="30" />
        <input type="submit" name="find" value="<?php echo JText::_('Set');?>" />
    </form>
</div>
<?php
}
?>
