<?php
defined('_JEXEC') or die('Restricted access'); 

class CFChronoForm extends JObject{
	var $formrow = NULL;
	var $formparams = NULL;
	var $formerrors = '';
	var $formdebug = '';
	var $error_found = false;
	var $stoprunning = false;
	var $tablerow = array();
	function __construct($formname = ''){
		if (!empty($formname)) {
			$this->getForm(trim($formname));
		}
		else
		{
			//todo: need to load default table properties
			//initialise
			$this->getForm(trim(JRequest::getVar( 'chronoformname')));
		}
	}
	function &getInstance($formname = ''){
		static $instances;
		if (!isset ($instances)) {
			$instances = array ( new CFChronoForm($formname) );
		}
		return $instances[0];
	}
	function getForm( $formname )
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		$query     = "SELECT * FROM `#__chrono_contact` WHERE `name` = '".$formname."'";
		$database->setQuery( $query );
		$cf_rows = $database->loadObjectList();
		$this->formrow = $cf_rows[0];
		//load titles
		$registry = new JRegistry();
		$registry->loadINI( $cf_rows[0]->titlesall );
		$titlesvalues = $registry->toObject( );
		//load params
		$registry = new JRegistry();
		$registry->loadINI( $cf_rows[0]->paramsall );
		$paramsvalues = $registry->toObject( );
		$this->formparams = $paramsvalues;
		
		if(count($cf_rows)){
			return true;
		}else{
			return false;
		}
	}	
	
	function setFormParam( $param, $value )
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		$this->formparams->$param = $value;
	}
	function setFormData( $key, $value )
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		$this->formrow->$key = $value;
	}
	
	function getFormName( $formid )
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		$query     = "SELECT * FROM `#__chrono_contact` WHERE `id` = '".$formid."'";
		$database->setQuery( $query );
		$cf_rows = $database->loadObjectList();
		
		if(count($cf_rows)){
			return $cf_rows[0]->name;
		}else{
			return false;
		}
	}
	function addErrorMsg( $text )
	{
		$this->formerrors = $this->formerrors.'<li>'.$text.'</li>';
	}
	function addDebugMsg( $text )
	{
		$this->formdebug = $this->formdebug.'<li>'.$text.'</li>';
	}	
	
	function showForm($formname, $posted = NULL)
	{		
		$MyForm =& CFChronoForm::getInstance($formname);		
		HTML_ChronoContact::showform( $MyForm->formrow, $posted);
	}
	
	function checkSubmissionsLimit($formname)
	{		
		global $mainframe;
		$session =& JFactory::getSession();
		$MyForm =& CFChronoForm::getInstance($formname);		
		if(trim($MyForm->formparams->submissions_limit)){
			if(!$session->get('chrono_submissions_limit', 'default', md5('chrono'))){
				$session->set("chrono_submissions_limit", mktime(date("H"), date("i"), date("s"), date("m")  , date("d")+1, date("Y")), md5('chrono'));
			}else{
				if(($session->get('chrono_submissions_limit', 'default', md5('chrono')) + ((int)trim($MyForm->formparams->submissions_limit))) > mktime(date("H"), date("i"), date("s"), date("m")  , date("d")+1, date("Y"))){
					$MyForm->addErrorMsg('Sorry but you can not submit the form again very soon like this!');
				}else{
					$session->set("chrono_submissions_limit", mktime(date("H"), date("i"), date("s"), date("m")  , date("d")+1, date("Y")), md5('chrono'));
				}
			}
		}
	}
	
	function checkImageVerification($formname)
	{
		global $mainframe;
		$session =& JFactory::getSession();
		$MyForm =& CFChronoForm::getInstance($formname);
		if ( trim($MyForm->formparams->imagever) == 'Yes' ) {
			$sessionvar = $session->get('chrono_verification', 'default', md5('chrono'));
			$chrono_verification = strtolower(JRequest::getVar('chrono_verification'));
			if ( md5($chrono_verification ) != $sessionvar ) {
				trim($MyForm->formparams->imgver_error_msg) ? $MyForm->addErrorMsg(trim($MyForm->formparams->imgver_error_msg)) : $MyForm->addErrorMsg(trim('You have entered an incorrect verification code at the bottom of the form.'));
			}else{
				$session->clear('chrono_verification', md5('chrono'));
				//$session->clear('chrono_verification_msg');
			}
		}
	}
	
	function checkServerValidation($formname)
	{
		global $mainframe;
		$session =& JFactory::getSession();
		$MyForm =& CFChronoForm::getInstance($formname);
		if ( trim($MyForm->formparams->servervalidate) == 'Yes' ) {
			if ($returnval = eval( "?>".$MyForm->formrow->server_validation )){
				$MyForm->addErrorMsg($returnval);
			}
		}
	}
	
	function submitForm($formname, $posted = array())
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		if(empty($posted)){
			$posted = JRequest::get( 'post' , JREQUEST_ALLOWRAW );
		}
		$MyForm =& CFChronoForm::getInstance($formname);
		$MyFormEmails =& CFEMails::getInstance($MyForm->formrow->id);
		$MyCustomCode =& CFCustomCode::getInstance($MyForm->formrow->id);
		
		$debug = $MyForm->formparams->debug;		
		$MyForm->addDebugMsg('Form passed first SPAM check OK');		
		$session =& JFactory::getSession();	
		// Check how soon was the last submission
		$MyForm->checkSubmissionsLimit($MyForm->formrow->name);	
		$MyForm->addDebugMsg('Form passed the submissions limit (if enabled) OK');		
		/**
		 * If imageversification is on check the code
		 */
		$MyForm->checkImageVerification($MyForm->formrow->name);
		$MyForm->addDebugMsg('Form passed the Image verification (if enabled) OK');		
		//Server side validation	
		$MyForm->checkServerValidation($MyForm->formrow->name);
		$MyForm->addDebugMsg('Form passed the server side validation (if enabled) OK');		
		//if any check steps failed, quit and reshow the form
		if($MyForm->formerrors){
			$MyForm->showForm($MyForm->formrow->name, $posted);
			return;
		}
		/**
		 * if $debug is true then ChronoForms will show diagnostic output
		 */   
		$MyForm->addDebugMsg("\$_POST Array: ".print_r($posted, true));
		$MyForm->addDebugMsg("\$_FILES Array: ".print_r($_FILES, true));
		/**
		 * Upload attachments
		 */
		$MyUploads =& CFUploads::getInstance($MyForm->formrow->id);
		$MyUploads->handleUploads();
		if($MyForm->formerrors){
			$MyForm->showForm($MyForm->formrow->name, $posted);
			return;
		}
		/* Do Onsubmit before_email plugins*/
		$MyPlugins =& CFPlugins::getInstance($MyForm->formrow->id);
		$MyPlugins->runPlugin('before_email');		
		$MyForm->addDebugMsg('Form passed the plugins step (if enabled) OK');		
		/**
		 * If there are no errors and e-mail is required then build and send it.
		 */
		if ( ($MyForm->formrow->emailresults != 0) && !$MyForm->error_found && !$MyForm->stoprunning ) {		
			//run before submit code
			$MyCustomCode->runCode( 'onsubmitcodeb4' );
			$MyCustomCode->runCode( 'autogenerated', 'before_email' );			
			//send emails
			$emails_result = $MyFormEmails->sendEmails($MyForm, $MyFormEmails->emails);			
		}	
	
		if ( !$MyForm->error_found && !$MyForm->stoprunning ) {
		/*************** check to see if order was specified, if not then use the default old one ************************/
			if((!$MyForm->formparams->plugins_order)&&(!$MyForm->formparams->onsubmitcode_order)&&(!$MyForm->formparams->autogenerated_order)){
				$MyForm->formparams->autogenerated_order=3;
				$MyForm->formparams->onsubmitcode_order=2;
				$MyForm->formparams->plugins_order=1;
			}
	
			for($ixx = 1 ; $ixx <= 3; $ixx++){
				if($MyForm->formparams->plugins_order == $ixx){
					$MyPlugins->runPlugin('after_email');
				}
				/**
				 * Run the On-submit 'post e-mail' code if there is any
				 */
				if($MyForm->formparams->onsubmitcode_order == $ixx){
					$MyCustomCode->runCode( 'onsubmitcode' );
				}
	
				/**
				 * Run the SQL query if there is one
				 */
				if($MyForm->formparams->autogenerated_order == $ixx){
					$MyCustomCode->runCode( 'autogenerated', 'after_email' );
				}
			}			
			$MyForm->addDebugMsg('Debug End');			
			/**
			 * Redirect the page if requested
			 */
			if ( !empty($MyForm->formrow->redirecturl) ) {
				if ( !$debug ) {
					$mainframe->redirect($MyForm->formrow->redirecturl);
				} else {
					$MyForm->addDebugMsg("<div class='debug' >Redirect link set, click to test:<br /><a href='".$MyForm->formrow->redirecturl."'>".$MyForm->formrow->redirecturl."</a></div>");
				}
			}
		}
		if((!empty($MyForm->formdebug))&&($MyForm->formparams->debug == '1')){
			include_once(JPATH_COMPONENT.DS.'libraries'.DS.'includes'.DS.'Debug.php');
		}
	}
	
	function doExtra($formname, $extraid = 1, $posted = array())
	{
		global $mainframe;
		$database =& JFactory::getDBO();
		if(empty($posted)){
			$posted = JRequest::get( 'post' , JREQUEST_ALLOWRAW );
		}
		if(empty($extraid)){
			$extraid = 1;
		}
		if(((int)$extraid == 0)||($extraid > 5)){
			return false;
		}
		$MyForm =& CFChronoForm::getInstance($formname);
		if ( !empty($MyForm->formrow->{"extra".$extraid}) ){
			eval( "?>".$MyForm->formrow->{"extra".$extraid} );
		}else{
			return false;
		}		
	}
	
}