<?php
/*
 **********************************************
 JCal Pro v1.5.3
 Copyright (c) 2006-2007 Anything-Digital.com
 **********************************************
 JCal Pro is a fork of the existing Extcalendar component for Joomla!
 (com_extcal_0_9_2_RC4.zip from mamboguru.com).
 Extcal (http://sourceforge.net/projects/extcal) was renamed
 and adapted to become a Mambo/Joomla! component by
 Matthew Friedman, and further modified by David McKinnis
 (mamboguru.com) to repair some security holes.

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This header must not be removed. Additional contributions/changes
 may be added to this header as long as no information is deleted.
 **********************************************

 $Id: event.inc.php 127 2009-04-04 17:51:38Z shumisha $

 **********************************************
 Get the latest version of JCal Pro at:
 http://dev.anything-digital.com//
 **********************************************
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class ExtCal_Event {
  // Set default variables for all new objects

  // Info related variables
  var $title = "";
  var $description = "";
  var $contact = "";
  var $url = "";
  var $link = "";
  var $email = "";
  var $picture = "";
  var $color = "#000000"; // black color by default
  var $catName = "";
  var $catDesc = "";

  // Date related variables
  var $startDate = NULL;
  var $endDate = NULL;

  var $startDay = 0;
  var $startMonth = 0;
  var $startYear = 0;

  var $endDay = 0;
  var $endMonth = 0;
  var $endYear = 0;

  var $recurStartDate = NULL; // virtual start and end dates used for recurrent events
  var $recurEndDate = NULL;

  // Other info variables
  var $extid = 0;
  var $catId = 0;
  var $status   = false;  // true means approved or active event
  var $recType = NULL; // Recurrence type: daily, weekly, monthly, yearly or (null for non recurrent events)
  var $recInterval = 0; // Period of recurrence
  var $recEndDate = 0; // recurrence limit
  var $recEndType = 0; // recurrence end type: 0. repeat indefinitely, 1. repeat a number of occurrences, 2. repeat until date ($recEndDate)
  var $recEndCount = NULL; // number of occurrences for a recurrent event. Used in conjunction with $recEndType = 1

  function Event() {
    // defining the constructor
    //global $CONFIG_EXT;
     
    //if($eventId) $this->getEvent($eventId);
  }

  function isActive() {
    return $this->$this->status;
  }

  /**
   * $date_stamp must be a user timestamp, not UTC
   *
   * @param unknown_type $eventId
   * @param unknown_type $date_stamp
   * @return unknown
   */
  function loadEvent($eventId,$date_stamp=false) {
    // function that retrieves and set event info
    global $CONFIG_EXT, $CFG, $params, $mainframe;
    $database = &JFactory::getDBO();

    $query = "SELECT e.*,cat_name, color, c.description AS cat_desc  FROM ".$CONFIG_EXT['TABLE_EVENTS']." AS e ";
    $query .= "LEFT JOIN ".$CONFIG_EXT['TABLE_CATEGORIES']." AS c ON e.cat=c.cat_id WHERE extid='".$eventId."'";
    $results = extcal_db_query($query);

    $rows = extcal_db_num_rows($results);
     
    if (!$rows) {
      return false;
    } else
    {
      $row = extcal_db_fetch_array($results);
      // additional field processing


      // Store info related variables
      $this->title = $row['title'];
      $this->description = $row['description'];
      $this->contact = $row['contact'];
      if($row['url']) {
        $this->url = eregi("/^(http[s]?:\/\/)",$row['url'])?$row['url']:"http://".$row['url'];
      } else {
        $this->url = "";
      }
      $this->link = $this->url;

      $this->email = $row['email'];

      $this->picture = $row['picture'];
      $this->color = $row['color'];
      $this->catName = $row['cat_name'];
      $this->catDesc = $row['cat_desc'];

    		// Store date related variables
      $this->start_date = $row['start_date'];
      $this->end_date = $row['end_date'];
      $this->recur_type = $row['recur_type'];
      $this->recur_val = $row['recur_val'];
      $this->recur_end_type = $row['recur_end_type'];
      $this->recur_count = $row['recur_count'];
      $this->recur_until = $row['recur_until'];
      $this->startDate = jcUTCDateToTs( $row['start_date']);
      if($row['start_date'] > $row['end_date']) {
        $this->endDate = $this->startDate;
      } else {
        $this->endDate = jcUTCDateToTs( $row['end_date']);
      }
      $this->startDay = jcUTCDateToFormatNoOffset( $this->startDate, '%d');
      $this->startMonth = jcUTCDateToFormatNoOffset( $this->startDate, '%m');
      $this->startYear = jcUTCDateToFormatNoOffset( $this->startDate, '%Y');
      $this->startHour = jcUTCDateToFormatNoOffset( $this->startDate, '%H');
      $this->startMinute = jcUTCDateToFormatNoOffset( $this->startDate, '%M');

      $this->endDay = jcUTCDateToFormatNoOffset( $this->endDate, '%d');
      $this->endMonth = jcUTCDateToFormatNoOffset( $this->endDate, '%m');
      $this->endYear = jcUTCDateToFormatNoOffset( $this->endDate, '%Y');
      $this->endHour = jcUTCDateToFormatNoOffset( $this->endDate, '%Y');
      $this->endMinute = jcUTCDateToFormatNoOffset( $this->endDate, '%M');

      // Store other info variables
      $this->extid = $eventId;
      $this->catId = (int)$row['cat'];
      $this->status = $row['approved']?true:false;
      $this->published = $row['published']?true:false;
      $this->recType = $row['recur_type'];
      $this->recInterval = (int)$row['recur_val'];
      $this->recEndDate = jcUTCDateToTs( $row['recur_until']);
      //$this->recWeekDays = $row['rec_weekdays'];
      $this->recEndType = (int)$row['recur_end_type'];
      $this->recEndCount = (int)$row['recur_count'];

      if ($date_stamp && $this->isRecurrentOn( startOfDayInUserTime( $date_stamp))) {
        $this->startDate = $this->recurStartDate;
        $this->endDate = $this->recurEndDate;
      }
    }
    extcal_db_free_result($results);
    return true;
  }

  function getDuration() {
    //function datestoduration ($periods = null) {
    $periods = null;
    $seconds = $this->endDate - $this->startDate;

    // Force the seconds to be numeric
    $seconds = (int)$seconds;
    // Define our periods
    if (!is_array($periods)) {
      $periods = array (
      //'years'     => 31556926,
      //'months'    => 2629743,
      //'weeks'     => 604800,
		  	'days'      => 86400,                    
		  	'hours'     => 3600,                    
		  	'minutes'   => 60,                    
      //'seconds'   => 1
      );
    }

    // Loop through
    foreach ($periods as $period => $value) {
      $count = floor($seconds / $value);
      $values[$period] = $count;
      if ($count == 0) {
        continue;
      }
      $seconds = $seconds % $value;
    }
    // Return array
    if (empty($values)) {
      $values = null;
    }

    // fix the all day value
    if(date("G:i",$this->endDate) == "23:59") {
      $values['days']++;
      $values['hours'] = 0;
      $values['minutes'] = 0;
    }
     
    return $values;
  }

  function isRecurrent() {
    return empty($this->recType)?false:true;
  }

  function setStartDate($start_date) {
     
    $this->startDate = $start_date;
    $this->startDay = jcUTCDateToFormat( $this->startDate, '%d');
    $this->startMonth = jcUTCDateToFormat( $this->startDate, '%m');
    $this->startYear = jcUTCDateToFormat( $this->startDate, '%Y');
  }

  function setEndDate($end_date) {
    $this->endDate = $end_date;
    $this->endDay = jcUTCDateToFormat( $this->endDate, '%d');
    $this->endMonth = jcUTCDateToFormat( $this->endDate, '%m');
    $this->endYear = jcUTCDateToFormat( $this->endDate, '%Y');
  }
 
  function isRecurrentOn( $target_stamp) { // target_stamp is TS of 00:00 on the required day in user time
    global $CONFIG_EXT, $mainframe;
    if(!$this->isRecurrent() || !is_numeric( $target_stamp)) return false;  // target_stamp can contain 'No recurrence found' if we are after the last recurrence, and show pas events is on
    $day = (int) $this->startDay;
    $month = (int) $this->startMonth;
    $year = (int) $this->startYear;
    $hour = (int) jcUTCDateToFormat( $this->startDate, '%H');
    $minute = (int) jcUTCDateToFormat( $this->startDate, '%M');
    $current_stamp = gmmktime( $hour,$minute, 0, $month, $day, $year); 

    // Now we find the number of DAYS the duration is. This can change depending on start time, you see, because an event that lasts 3 hours
    // but starts at 11 pm has a duration of 2, if you're just counting in days.
    $endDay = (int) $this->endDay;
    $endMonth = (int) $this->endMonth; 
    $endYear = (int) $this->endYear;
    $duration = mktime(0,0,0,$endMonth, $endDay,$endYear) - mktime(0,0,0,$month,$day,$year);
    $exact_duration = $this->endDate - $this->startDate;
    $difference_in_days = mktime(0,0,0,($endMonth - $month) + 1,($endDay - $day) + 1,($endYear - $year) + 1980);
    $duration_in_days = ( $difference_in_days - mktime(0,0,0,1,1,1980) ) / 86400;

    if($this->recEndType == 2 && ($this->recEndDate + $duration < $target_stamp)) return false;

    // $this->$recur_nextStartStamp is false by default. But if isRecurrentOn() has run before
    // on this event and has calculated that overlapping recurrences exist, the property will
    // hold the timestamp of what it has calculated to be the start DAY (no time values) of the
    // next recurrence.
    //if ($this->$recur_nextStartStamp) $target_stamp = $recur_nextStartStamp;
     
    if ( isset ( $recur_nextStartStamp ) )
    {
      if ($recur_nextStartStamp) $target_stamp = $recur_nextStartStamp;
    }
     
    /* $target_day = (int)date("d", $target_stamp);
    $target_month = (int)date("m", $target_stamp);
    $target_year = (int)date("Y", $target_stamp); */
    
    $target_day= jcUserDateToFormat( $target_stamp, '%d');
    $target_month = jcUserDateToFormat( $target_stamp, '%m');
    $target_year = jcUserDateToFormat( $target_stamp, '%Y'); 
    
    $target_stamp = gmmktime($hour,$minute,0,$target_month,$target_day,$target_year); // reformat the target date without time info
    $recur_count = 1;
     
    // At this point, The target stamp is the day we're checking whether the event falls on.
    // The current stamp is the original start date of the event.
     
    $this->recurrencesOnThisDate = array();  // We're gonna store all recurrences of this event on this day.

    $first_time_through = true;

    while( $this->recInterval && ( ($this->recEndType != 1 && $current_stamp <= $target_stamp) || ($this->recEndType == 1 && $recur_count <= $this->recEndCount && $current_stamp <= $target_stamp) ) ) {
      // Then the current stamp is updated as the date is incremented by the recur interval until it comes up to the target date.
      $incrementBy = ( $first_time_through ) ? 0 : $this->recInterval;
      switch($this->recType) {
        case "day":
          $current_stamp = gmmktime($hour,$minute,0,$month,$day+$incrementBy,$year);
          $exact_current_stamp = gmmktime($hour,$minute,0,$month,$day+=$incrementBy,$year);
          break;
        case "week":
          $current_stamp = gmmktime($hour,$minute,0,$month,$day+($incrementBy*7),$year);
          $exact_current_stamp = gmmktime($hour,$minute,0,$month,$day+=($incrementBy*7),$year);
          break;
        case "month":
          $current_stamp = gmmktime($hour,$minute,0,$month+$incrementBy,$day,$year);
          $exact_current_stamp =  gmmktime($hour,$minute,0,$month+=$incrementBy,$day,$year);
          break;
        case "year":
          $current_stamp = gmmktime($hour,$minute,0,$month,$day,$year+$incrementBy);
          $exact_current_stamp = gmmktime($hour,$minute,0,$month,$day,$year+=$incrementBy);
          break;
        default:
      }
      $first_time_through = false;

      $condition_all = $current_stamp <= $target_stamp && ($current_stamp + $exact_duration) >= $target_stamp;
      $condition_bounds = ($current_stamp == $target_stamp || ($current_stamp + $exact_duration) == $target_stamp);
      $condition_start = $current_stamp == $target_stamp;

      if((($condition_all && $CONFIG_EXT['multi_day_events']=="all") || ($condition_bounds && $CONFIG_EXT['multi_day_events']=="bounds") || ($condition_start && $CONFIG_EXT['multi_day_events']=="start")) && ($this->recEndType != 2 || $this->recEndDate >= $current_stamp)) {
        $this->recurrencesOnThisDate[] = array(
						'recurrence_start_day' => $current_stamp, // Timestamp with just the date
						'exact_recurrence_start' => $exact_current_stamp, // Exact timestamp of start, date AND time
						'recurrence_end_day' => $current_stamp + $duration, // Timestamp with just the date
						'exact_recurrence_end' => $exact_current_stamp + $exact_duration  // Exact timestamp of end, date AND time
        );
      }
      if(count($this->recurrencesOnThisDate)) {
        $finalRecurrence = $this->recurrencesOnThisDate[count($this->recurrencesOnThisDate)-1];
        $this->recurStartDay = $finalRecurrence['recurrence_start_day']; // Timestamp with just the date
        $this->recurStartDate = $finalRecurrence['exact_recurrence_start']; // Exact timestamp of start, date AND time
        $this->recurEndDay = $finalRecurrence['recurrence_end_day']; // Timestamp with just the date
        $this->recurEndDate = $finalRecurrence['exact_recurrence_end'];  // Exact timestamp of end, date AND time
      }
      if ( $CONFIG_EXT['show_recurrent_events'] == 2 ) break; // If the setting is to show First Only of recurring events, we break the loop so only the first occurrence is added.
      $recur_count++;
    }
     
    return (count($this->recurrencesOnThisDate)) ? true : false;
     
  }
  
  
  function get_icon($day_stamp,$start_stamp,$end_stamp) {

    $startbound = date('Ymd',$day_stamp) - date('Ymd',$start_stamp); // 0 means event starts same day
    $endbound = date('Ymd',$end_stamp) - date('Ymd',$day_stamp); // 0 means event ends same day
    //echo "STR:".date('Ymd',$start_stamp) . " STO:".date('Ymd',$end_stamp). " DAY:".date('Ymd',$day_stamp)."<br>";

    $image = "icon-event-onedate.gif"; // default event icon
    if(!$startbound && !$endbound) $image = "icon-event-onedate.gif";
    elseif(!$startbound && $endbound>0) $image = "icon-event-startdate.gif";
    elseif($startbound>0 && !$endbound) $image = "icon-event-enddate.gif";
    elseif($startbound>0 && $endbound>0) $image = "icon-event-middate.gif";
    //else return false;

    return $image;

  }

  function get_style($day_stamp,$start_stamp,$end_stamp) {

    $startbound = date('Ymd',$day_stamp) - date('Ymd',$start_stamp); // 0 means event starts same day
    $endbound = date('Ymd',$end_stamp) - date('Ymd',$day_stamp); // 0 means event ends same day

    $class = "eventfull"; // default event class
    if(!$startbound && !$endbound) $class = "eventfull";
    elseif(!$startbound && $endbound>0) $class = "eventstart";
    elseif($startbound>0 && !$endbound) $class = "eventend";
    elseif($startbound>0 && $endbound>0) $class = "eventmiddle";
    //else return false;
     
    return $class;

  }

}

?>
