<?php
/*
 * @package Joomla 1.5
 * @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 *
 * @plugin Phoca Plugin
 * @copyright Copyright (C) Jan Pavelka www.phoca.cz
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.application.component.helper' );

class plgContentPhocaMaps extends JPlugin
{	
	var $_plgPhocaMapsNr	= 0;
	
	function _setPhocaMapsPluginNumber() {
		$this->_plgPhocaMapsNr = (int)$this->_plgPhocaMapsNr + 1;
	}
	
	function plgContentPhocaMaps( &$subject, $params ) {
        parent::__construct( $subject, $params  );
    }

	function onPrepareContent( &$article, &$params, $limitstart ) {

		
		// Start Plugin
		$regex_one		= '/({phocamaps\s*)(.*?)(})/si';
		$regex_all		= '/{phocamaps\s*.*?}/si';
		$matches 		= array();
		$count_matches	= preg_match_all($regex_all,$article->text,$matches,PREG_OFFSET_CAPTURE | PREG_PATTERN_ORDER);

		
		
		// Start if count_matches
		
		if ($count_matches != 0) {
		
			$document		= &JFactory::getDocument();
			$db 			= &JFactory::getDBO();
			$menu 			= &JSite::getMenu();			
			$plugin 		= &JPluginHelper::getPlugin('content', 'phocamaps');
			$paramsP 		= new JParameter( $plugin->params );
			require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_phocamaps'.DS.'helpers'.DS.'phocamaps.php' );
			require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_phocamaps'.DS.'helpers'.DS.'phocamapsrenderfront.php' );
			$component 		= 'com_phocamaps';
			$table 			=& JTable::getInstance('component');
			$table->loadByOption( $component );
			$paramsC	 	= new JParameter( $table->params );
			$tmpl			= array();
			
			if (!JComponentHelper::isEnabled('com_phocamaps', true)) {
				JText::_('Phoca Maps Plugin requires Phoca Maps Component');
				return true;
			}
			
			$document->addStyleSheet(JURI::base(true).'/components/com_phocamaps/assets/phocamaps.css');
			
			for($i = 0; $i < $count_matches; $i++) {
				
				$this->_setPhocaMapsPluginNumber();
				$mC	= 'PlgPM'.(int)$this->_plgPhocaMapsNr;
				
				$view	= '';
				$id		= '';
				$text	= '';
				
				// Get plugin parameters
				$phocaMaps	= $matches[0][$i][0];
				preg_match($regex_one,$phocaMaps,$phocaMaps_parts);
				$parts			= explode("|", $phocaMaps_parts[2]);
				$values_replace = array ("/^'/", "/'$/", "/^&#39;/", "/&#39;$/", "/<br \/>/");

				
				foreach($parts as $key => $value) {
					$values = explode("=", $value, 2);
					foreach ($values_replace as $key2 => $values2) {
						$values = preg_replace($values2, '', $values);
					}
					
					// Get plugin parameters from article
						 if($values[0]=='view')				{$view				= $values[1];}
					else if($values[0]=='id')				{$id				= $values[1];}
					else if($values[0]=='text')				{$text				= $values[1];}
					
				}
				
				$output = '';
				switch($view) {
					
					// - - - - - - - - - - - - - - - -
					// Map
					// - - - - - - - - - - - - - - - -
					case 'map':	

						$query = 'SELECT a.*'
						.' FROM #__phocamaps_map AS a'
						.' WHERE a.id = '.(int) $id;
						$db->setQuery($query);
						$map = $db->loadObject();
						
						$query = 'SELECT a.*'
								.' FROM #__phocamaps_marker AS a'
								.' LEFT JOIN #__phocamaps_map AS c ON c.id = a.catid '
								.' WHERE c.id = '.(int) $id
								.' AND a.published = 1';
						$db->setQuery($query);
						$marker = $db->loadObjectList();
						
						if (empty($map)) {
							JError::raiseError('Phoca Maps Plugin Error', JText::_('Map does not exist or is unpublished') . ' (ID = '.$id.')');
						}
						
						// Parameters
						$tmpl['apikey']					= $paramsC->get( 'google_maps_api_key', '' );
						$tmpl['displayphocainfo']		= $paramsC->get( 'display_phoca_info', 1 );
						$tmpl['displaymapdescription']	= $paramsP->get( 'display_map_description', 0 );
// - - - - - - - - - - - - - - - 						
// RENDER

if ($tmpl['apikey'] == '') {
	$output .= '<p>' . JText::_('Google Maps API Key Error Front') . '</p>';

} else if ((!isset($map->longitude))
		|| (!isset($map->latitude))
		|| (isset($map->longitude) && $map->longitude == '')
		|| (isset($map->latitude) && $map->latitude == '')) {
	$output .= '<p>' . JText::_('Google Maps Error Front') . '</p>';

} else {

	if (isset($map->description) && $map->description != '' && $tmpl['displaymapdescription'] == 1) {
		$output .= '<div class="pm-desc">'.$map->description.'</div>';
	}

	// Basic settings
	$fullWidth = 0;
	if (!isset($map->width)) {
		$map->width = 400;
	}
	if (isset($map->width) && (int)$map->width < 1) {
		$fullWidth = 1;
	}
	if (!isset($map->height) || (isset($map->height) && (int)$map->height < 1)) {
		$map->height = 400;
	}
	if (!isset($map->zoom) || (isset($map->zoom) && (int)$map->zoom < 1)) {
		$map->height = 2;
	}
	$mapLang = '';
	if (!isset($map->lang) || (isset($map->lang) && $map->lang =='')) {
		$mapLang = '';
	} else {
		$mapLang = ', {"language" : "'.$map->lang.'"}';
	}

	
	$border = '';
	if (isset($map->border)) {
		switch ($map->border) {
			case 1:
				$border = '-grey';
			break;
			case 2:
				$border = '-greywb';
			break;
			case 3:
				$border = '-greyrc';
			break;
			case 4:
				$border = '-black';
			break;

		}
	}	
	
	//$document	= & JFactory::getDocument();
	$scriptLink	= 'http://www.google.com/jsapi?key='. $tmpl['apikey'];
	$document->addScript($scriptLink);
	$output.= '<noscript>'. JText::_('GOOGLE MAP ENABLE JAVASCRIPT').'</noscript>';


	$styleSiteWidth = '';
	if ($fullWidth == 1) {
		$styleSiteWidth = 'style="width:100%"';
	}
	
	// Map Box
	if ($border == '') {
		$output .= '<div style="margin:0;padding:0;margin-top:10px;">';
		if ($fullWidth == 1) {
			$output .= '<div id="phoca_map'.$mC.'" style="margin:0;padding:0;width:100%;height:'.$map->height.'px"></div>';
		} else {
			$output .= '<div id="phoca_map'.$mC.'" style="margin:0;padding:0;width:'.$map->width.'px;height:'.$map->height.'px"></div>';
		}
		$output .= '</div>';
	} else {
		$output .= '<div id="phocamaps"><div class="pmbox'.$border.'" '.$styleSiteWidth.'><div><div><div>';
		if ($fullWidth == 1) {
			$output .= '<div id="phoca_map'.$mC.'" style="width:100%;height:'.$map->height.'px"></div>';
		} else {
			$output .= '<div id="phoca_map'.$mC.'" style="width:'.$map->width.'px;height:'.$map->height.'px"></div>';
		}
		$output .= '</div></div></div></div></div>';
	}

	if (isset($map->displayroute) && $map->displayroute == 1) {
		if (isset($marker) && !empty($marker)) {
			
			$countMarker = count($marker);
			if ((int)$countMarker > 1) {
				$output.='<div class="pmroute"><form action="#" onsubmit="setDirections'.$mC.'(this.pmfrom'.$mC.'.value, this.pmto'.$mC.'.value, \'\'); return false">';
				$output.=JText::_('From Address').': <input type="text" size="30" id="fromPMAddress'.$mC.'" name="pmfrom'.$mC.'" value=""/>';
				$output.=' ' . JText::_('To').': <select name="pmto'.$mC.'" id="toPMAddress'.$mC.'">';
				foreach ($marker as $key => $markerV) {
					if ((isset($markerV->longitude) && $markerV->longitude != '')
					&& (isset($markerV->latitude) && $markerV->latitude != '')) {
						$output.='<option value="'.$markerV->latitude.','.$markerV->longitude.'">'.$markerV->title.'</option>';
					}
				}
				$output.='</select>';
				$output.=' <input name="pmsubmit'.$mC.'" type="submit" value="'.JText::_('Get Route').'" /></form></div>';
				$output.='<div id="phoca_dir'.$mC.'"></div>';
			} else if ((int)$countMarker == 1) {
				$output.='<div class="pmroute"><form action="#" onsubmit="setDirections'.$mC.'(this.pmfrom'.$mC.'.value, this.pmto'.$mC.'.value, \'\'); return false">';
				$output.=JText::_('From Address').': <input type="text" size="30" id="fromPMAddress'.$mC.'" name="pmfrom'.$mC.'" value=""/>';
				foreach ($marker as $key => $markerV) {
					if ((isset($markerV->longitude) && $markerV->longitude != '')
					&& (isset($markerV->latitude) && $markerV->latitude != '')) {
						$output.='<input name="pmto'.$mC.'" id="toPMAddress'.$mC.'" type="hidden" value="'.$markerV->latitude.','.$markerV->longitude.'" />';
					}
				}
				$output.=' <input name="pmsubmit'.$mC.'" type="submit" value="'.JText::_('Get Route').'" /></form></div>';
				$output.='<div id="phoca_dir'.$mC.'"></div>';
			}
		}
	}
	


$output.='<script type="text/javascript">//<![CDATA[\''."\n"
.'google.load("maps", "2.x"'. $mapLang .');'."\n"
.'google.load("search", "1"'. $mapLang .');'."\n"
.''."\n"
.'var tstPhocaMap'.$mC.'=document.getElementById(\'phoca_map'.$mC.'\');'."\n"
.'var tstIntPhocaMap'.$mC.';'."\n"
.'var mapPhocaMap'.$mC.';'."\n"
.'var dirPhocaMap'.$mC.';'."\n"
.''."\n"
.'function CancelEventPhocaMap'.$mC.'(event) { '."\n"
.'	var e = event; '."\n"
.'	if (typeof e.preventDefault == \'function\') e.preventDefault(); '."\n"
.'	if (typeof e.stopPropagation == \'function\') e.stopPropagation(); '."\n"
.'	'."\n"
.'	if (window.event) { '."\n"
.'		window.event.cancelBubble = true; // for IE '."\n"
.'		window.event.returnValue = false; // for IE '."\n"
.'	} '."\n"
.'}'."\n"
.''."\n"
.''."\n"
.'function CheckPhocaMap'.$mC.'()'."\n"
.'{'."\n"
.'	if (tstPhocaMap'.$mC.') {'."\n"
.'		if (tstPhocaMap'.$mC.'.offsetWidth != tstPhocaMap'.$mC.'.getAttribute("oldValue'.$mC.'"))'."\n"
.'		{'."\n"
.'			tstPhocaMap'.$mC.'.setAttribute("oldValue'.$mC.'",tstPhocaMap'.$mC.'.offsetWidth);'."\n"
.''."\n"
.'			if (tstPhocaMap'.$mC.'.getAttribute("refreshMap'.$mC.'")==0) {'."\n"
.'				if (tstPhocaMap'.$mC.'.offsetWidth > 0) {'."\n"
.'					clearInterval(tstIntPhocaMap'.$mC.');'."\n"
.'					getPhocaMap'.$mC.'();'."\n"
.'					tstPhocaMap'.$mC.'.setAttribute("refreshMap'.$mC.'", 1);'."\n"
.'				} '."\n"
.'			}'."\n"
.'		}'."\n"
.'	}'."\n"
.'}'."\n"
.''."\n"
.''."\n"
.'// Call this function when the page has been loaded'."\n"
.'function getPhocaMap'.$mC.'(){'."\n"
.'	if (tstPhocaMap'.$mC.'.offsetWidth > 0) {'."\n"
.'	'."\n"
.'		mapPhocaMap'.$mC.' = new GMap2(document.getElementById(\'phoca_map'.$mC.'\'));'."\n";

if (isset($map->displayroute) && $map->displayroute == 1) {
	if (isset($marker) && !empty($marker)) {
		$output.='		dirPhocaMap'.$mC.' = new GDirections(mapPhocaMap'.$mC.', document.getElementById("phoca_dir'.$mC.'"));'."\n"
		.'		GEvent.addListener(dirPhocaMap'.$mC.', "error", handleErrors'.$mC.');'."\n";
	}
}

$output.='      mapPhocaMap'.$mC.'.setCenter(new GLatLng('.$map->latitude.', '.$map->longitude.'),'.$map->zoom.');'."\n";
		
if (isset($map->continuouszoom) && (int)$map->continuouszoom == 1) {
	$output .= 'mapPhocaMap'.$mC.'.enableContinuousZoom();' ."\n";
} else {
	$output .= 'mapPhocaMap'.$mC.'.disableContinuousZoom();' ."\n";
}

if (isset($map->doubleclickzoom) && (int)$map->doubleclickzoom == 1) {
	$output .= 'mapPhocaMap'.$mC.'.enableDoubleClickZoom();' ."\n";
} else {
	$output .= 'mapPhocaMap'.$mC.'.disableDoubleClickZoom();' ."\n";
}

if (isset($map->scrollwheelzoom) && (int)$map->scrollwheelzoom == 1) {

	$output .= 'mapPhocaMap'.$mC.'.enableScrollWheelZoom();' ."\n";
} else {
	$output .= 'mapPhocaMap'.$mC.'.disableScrollWheelZoom();' ."\n";
}

if (isset($map->zoomcontrol)) {
	switch ($map->zoomcontrol) {
		
		case 1:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GLargeMapControl3D());' ."\n";
		break;
		case 2:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GLargeMapControl());' ."\n";
		break;
		case 3:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GSmallZoomControl3D());' ."\n";
		break;
		case 4:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GSmallZoomControl());' ."\n";
		break;
		default;
			$output .= '' ."\n";
		break;
	}
}

if (isset($map->scalecontrol) && (int)$map->scalecontrol == 1) {
	$output .= 'mapPhocaMap'.$mC.'.addControl(new GScaleControl());' ."\n";
}

if (isset($map->typecontrol)) {
	
	
	
	switch ($map->typecontrol) {
		
		case 1:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GMapTypeControl());' ."\n";
		break;
		case 2:
			$output .= 'mapPhocaMap'.$mC.'.setMapType(G_NORMAL_MAP);' ."\n";
		break;
		case 3:
			$output .= 'mapPhocaMap'.$mC.'.setMapType(G_SATELLITE_MAP);' ."\n";
		break;
		case 4:
			$output .= 'mapPhocaMap'.$mC.'.setMapType(G_HYBRID_MAP);' ."\n";
		break;
		case 5:
			$output .= 'mapPhocaMap'.$mC.'.setMapType(G_PHYSICAL_MAP);' ."\n";
		break;
		case 6:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GHierarchicalMapTypeControl());' ."\n";
		break;
		case 7:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GMapTypeControl());' ."\n";
			$output .= 'mapPhocaMap'.$mC.'.setMapType(G_SATELLITE_MAP);' ."\n";
		break;
		
		case 8:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GMapTypeControl());' ."\n";
			$output .= 'mapPhocaMap'.$mC.'.setMapType(G_HYBRID_MAP);' ."\n";
		break;
		case 9:
			$output .= 'mapPhocaMap'.$mC.'.addControl(new GMapTypeControl());' ."\n";
			$output .= 'mapPhocaMap'.$mC.'.setMapType(G_PHYSICAL_MAP);' ."\n";
		break;
		default;
			$output .= '' ."\n";
		break;
	}
}

if (isset($map->collapsibleoverview) && (int)$map->collapsibleoverview == 1) {
	$output .= 'mapPhocaMap'.$mC.'.addControl(new GOverviewMapControl());' ."\n";
}

if (isset($map->dynamiclabel) && (int)$map->dynamiclabel == 1) {
	$output .= 'mapPhocaMap'.$mC.'.addControl(new GNavLabelControl());' ."\n";
}

if (isset($map->googlebar) && (int)$map->googlebar == 1) {
	$output .= 'mapPhocaMap'.$mC.'.enableGoogleBar();' ."\n";
}


// Markers
jimport('joomla.filter.output');
if (isset($marker) && !empty($marker)) {

	foreach ($marker as $key => $markerV) {
	
		if ((isset($markerV->longitude) && $markerV->longitude != '')
		&& (isset($markerV->latitude) && $markerV->latitude != '')) {
			
			$text =  '<h1>' . addslashes($markerV->title) . '</h1>';
			$text .= '<div>'. PhocaMapsHelper::strTrimAll(addslashes($markerV->description)).'</div>';
			if ($markerV->displaygps == 1) {
				$text .= '<div class="pmgps"><table border="0"><tr><td><strong>'. JText::_('GPS') . ': </strong></td>'
						.'<td>'.PhocaMapsHelper::strTrimAll(addslashes($markerV->gpslatitude)).'</td></tr>'
						.'<tr><td></td>'
						.'<td>'.PhocaMapsHelper::strTrimAll(addslashes($markerV->gpslongitude)).'</td></tr></table></div>';
			}
			
			$iconOutput = PhocaMapsRenderFront::renderMarkerIcon($markerV->icon);
			$output .= $iconOutput['js'];


			$output.='var point'.$markerV->id.$mC.' = new GPoint( '.$markerV->longitude.', '.$markerV->latitude.');'."\n";
			$output.='var markerPhocaMarker'.$markerV->id.$mC.' = new GMarker(point'.$markerV->id.$mC.', {title:"'.$markerV->title.'"';
			if ($iconOutput['defaulticon'] == 0) { $output .= ', icon:phocaIcon';}
			$output.= '});'."\n";
			$output.='mapPhocaMap'.$mC.'.addOverlay(markerPhocaMarker'.$markerV->id.$mC.');'."\n";
			
			$output.='GEvent.addListener(markerPhocaMarker'.$markerV->id.$mC.', \'click\', function() {
				markerPhocaMarker'.$markerV->id.$mC.'.openInfoWindowHtml(\''.$text.'\');
				});'."\n";
				
			$output.='GEvent.addDomListener(tstPhocaMap'.$mC.', \'DOMMouseScroll\', CancelEventPhocaMap'.$mC.');'."\n";
			$output.='GEvent.addDomListener(tstPhocaMap'.$mC.', \'mousewheel\', CancelEventPhocaMap'.$mC.');'."\n";
		}
	}
}
$output.='	}'."\n";
$output.='}'."\n";
$output.=''."\n";


/*Directions*/
if (isset($map->displayroute) && $map->displayroute == 1) {
	if (isset($marker) && !empty($marker)) {
		
		$output.='function setDirections'.$mC.'(fromPMAddress'.$mC.', toPMAddress'.$mC.', locale'.$mC.') {'."\n"
		.'   dirPhocaMap'.$mC.'.load("from: " + fromPMAddress'.$mC.' + " to: " + toPMAddress'.$mC.''. $mapLang.');'."\n"
		.'}'."\n"
		.''."\n"
		.'function handleErrors'.$mC.'(){'."\n"
		.'	if (dirPhocaMap'.$mC.'.getStatus().code == G_GEO_UNKNOWN_ADDRESS) {'."\n"
		.'		alert("'.JText::_('No corresponding geographic location could be found for one of the specified addresses').'");'."\n"
		.'	} else if (dirPhocaMap'.$mC.'.getStatus().code == G_GEO_SERVER_ERROR) {'."\n"
		.'		alert("'.JText::_('Request could not be successfully processed').'");'."\n"
		.'	} else if (dirPhocaMap'.$mC.'.getStatus().code == G_GEO_MISSING_QUERY) {'."\n"
		.'		alert("'.JText::_('No query was specified in the input').'");'."\n"
		.'	} else if (dirPhocaMap'.$mC.'.getStatus().code == G_UNAVAILABLE_ADDRESS) {'."\n"
		.'		alert("'.JText::_('Route cannot be returned due to legal or contractual reasons').'");'."\n"
		.'	} else if (dirPhocaMap'.$mC.'.getStatus().code == G_GEO_BAD_KEY) {'."\n"
		.'		alert("'.JText::_('The given key is either invalid or does not match the domain for which it was given').'");'."\n"
		.'	} else if (dirPhocaMap'.$mC.'.getStatus().code == G_GEO_BAD_REQUEST) {'."\n"
		.'		alert("'.JText::_('Request could not be successfully parsed').'");'."\n"
		.'	} else if (dirPhocaMap'.$mC.'.getStatus().code == G_GEO_UNKNOWN_DIRECTIONS) {'."\n"
		.'		alert("'.JText::_('There is no route available between the two points, or there is no data for routing in that region').'");'."\n"
		.'	} else if (dirPhocaMap'.$mC.'.getStatus().code == G_GEO_TOO_MANY_QUERIES) {'."\n"
		.'		alert("'.JText::_('The given key has gone over the requests limit or has submitted too many requests in too short a period of time').'");'."\n"
		.'	} else {'."\n"
		.'		alert("'.JText::_('An unknown error occurred').'");'."\n"
		.'	}'."\n"
		.'}';
	
	}
}

$output.='function initialize'.$mC.'() {'."\n"
.'	if (GBrowserIsCompatible()) {'."\n"
.'		'."\n"
.'		tstPhocaMap'.$mC.'.setAttribute("oldValue'.$mC.'",0);'."\n"
.'		tstPhocaMap'.$mC.'.setAttribute("refreshMap'.$mC.'",0);'."\n"
.'		tstIntPhocaMap'.$mC.'=setInterval("CheckPhocaMap'.$mC.'()",500);'."\n"
.'	}'."\n"
.'}'."\n"
.''."\n"
.'google.setOnLoadCallback(initialize'.$mC.');'."\n"
.'//]]></script>';	


}
if ($tmpl['displayphocainfo'] == 1) {
	$output .= '<div style="text-align:right;margin-top:10px;clear:both;"><a href="http://www.phoca.cz/phocamaps">Phoca Maps</a></div>';
} else {
	$output .='<div style="clear:both;"></div>';
}

// END RENDER
// - - - - - - - - - - - - - - - 						
						
						
						
					break;
					
					// - - - - - - - - - - - - - - - -
					// Link
					// - - - - - - - - - - - - - - - -
					case 'link':
						if ((int)$id > 0) {
						
							$query = 'SELECT a.*,'
							. ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug'
							.' FROM #__phocamaps_map AS a'
							.' WHERE a.id = '.(int) $id;
							$db->setQuery($query);
							$map = $db->loadObject();
							
							
							$query = 'SELECT a.id'
								.' FROM #__phocamaps_marker AS a'
								.' LEFT JOIN #__phocamaps_map AS c ON c.id = a.catid '
								.' WHERE c.id = '.(int) $id
								.' AND a.published = 1';
							$db->setQuery($query);
							$marker = $db->loadObjectList();
							
							if (empty($map)) {
							JError::raiseError('Phoca Maps Plugin Error', JText::_('Map does not exist or is unpublished') . ' (ID = '.$id.')');
						}
							
						
							// Is there a Itemid for category
							$items	 = $menu->getItems('link', 'index.php?option=com_phocamaps&view=map&id='. $map->id);
							
							if(isset($items[0])) {
								$itemid = $items[0]->id;
								$linkMap = JRoute::_('index.php?option=com_phocamaps&view=map&id='. $map->id.'&tmpl=component&Itemid='.$itemid );
							} else {							
								$itemid = 0;
								$linkMap = JRoute::_('index.php?option=com_phocamaps&view=map&id='. $map->slug .'&tmpl=component' );
								
							}
							// ---------------------------------------------------------------------------------
					
							if ($text =='') {
								$text = JText::_('Link to Map');
							}
							
							// Parameters
							$tmpl['detailwindow']		= $paramsP->get( 'detail_window', 0 );
							$tmpl['mbbordercolor']		= $paramsP->get( 'modal_box_border_color', '#6b6b6b' );
							$tmpl['mbborderwidth']		= $paramsP->get( 'modal_box_border_width', 2 );
							$tmpl['mboverlaycolor']		= $paramsP->get( 'modal_box_overlay_color', '#000000' );
							$tmpl['mboverlayopacity']	= $paramsP->get( 'modal_box_overlay_opacity', 0.3 );
							
							
							if ($map->width > 0) {
								$tmpl['windowwidth'] = (int)$map->width + 20;
							} else {
								$tmpl['windowwidth'] = 640;
							}
							$tmpl['windowheight'] = (int)$map->height + 20;
							
							
							//Route
							if (isset($map->displayroute) && $map->displayroute == 1) {
								if (isset($marker) && !empty($marker)) {
									$tmpl['windowheight'] = (int)$tmpl['windowheight'] + 40;
								}
							}
							
							
							if ($tmpl['detailwindow'] == 1) {
								
								$button = new JObject();
								$button->set('name', 'phocamaps');
								$button->set('methodname', 'js-button');
								$button->set('options', "window.open(this.href,'win2','width=".$tmpl['windowwidth'].",height=".$tmpl['windowheight'].",menubar=no,resizable=yes'); return false;");
								$output .= '<a title="'.$text.'"  href="'.$linkMap.'" onclick="'. $button->options.'">'.$text.'</a>';
								
								
							} else if ($tmpl['detailwindow'] == 0) {
							
								// Button
								JHTML::_('behavior.modal', 'a.modal-button');
								$cssSbox = " #sbox-window {background-color:".$tmpl['mbbordercolor'].";padding:".$tmpl['mbborderwidth']."px} \n"
								." #sbox-overlay {background-color:".$tmpl['mboverlaycolor'].";} \n";
				
								$document->addCustomTag( "<style type=\"text/css\">\n" . $cssSbox . "\n" . " </style>\n");
								
								$button = new JObject();
								$button->set('name', 'phocamaps');
								$button->set('modal', true);
								$button->set('methodname', 'modal-button');
								$button->set('options', "{handler: 'iframe', size: {x: ".$tmpl['windowwidth'].", y: ".$tmpl['windowheight']."}, overlayOpacity: ".$tmpl['mboverlayopacity'].", classWindow: 'phocamaps-plugin-window', classOverlay: 'phocamaps-plugin-overlay'}");
							
								$output .= '<a class="modal-button" title="'.$text.'"  href="'.$linkMap.'" rel="'. $button->options.'">'.$text.'</a>';
							}
								
								
							
						}
					break;
					
				}
				$article->text = preg_replace($regex_all, $output, $article->text, 1);
			}
		}// end if count_matches
		return true;
	}
}
?>